
---------------- Constants ----------------

MAX_PICKING_DISTANCE = 0.6

STORMWIND_LOCATIONS = { 'CATHEDRAL', 'DWARVEN', 'OLD TOWN', 'TRADE', 'MAGE'}
STORMWIND_POS = {
	{1, {54.6, 59.4}},
	{1, {53.0, 51.9}},
	{1, {58.4, 55.1}},
	{2, {64.6, 30.9}},
	{2, {62.7, 37.0}},
	{2, {63.4, 41.7}},
	{2, {67.3, 44.7}},
	{3, {75.6, 53.4}},
	{3, {75.6, 64.6}},
	{3, {74.6, 59.2}},
	{3, {76.5, 68.5}},
	{4, {69.0, 73.1}},
	{4, {62.0, 76.9}},
	{4, {66.1, 75.7}},
	{4, {60.4, 68.8}},
	{5, {47.4, 81.6}},
	{5, {44.2, 87.9}},
	{5, {47.7, 89.4}},
	{5, {52.4, 83.4}}
}

ORGRIMMAR_LOCATIONS = { 'VSTRENGTH', 'SPIRITS', 'WISDOM', 'DRAG', 'HONOR'}
ORGRIMMAR_POS = {
	{1, {53.5, 82.0}},
	{1, {49.4, 68.7}},
	{1, {48.7, 83.8}},
	{2, {33.4, 65.7}},
	{2, {35.4, 69.4}},
	{2, {37.9, 84.5}},
	{2, {38.5, 80.7}},
	{3, {38.9, 49.9}},
	{3, {41.7, 44.8}},
	{3, {48.4, 44.1}},
	{3, {51.0, 45.2}},
	{4, {57.7, 65.1}},
	{4, {57.6, 58.6}},
	{4, {60.4, 55.1}},
	{4, {57.9, 48.6}},
	{5, {65.8, 50.6}},
	{5, {68.2, 42.9}},
	{5, {67.0, 37.4}},
	{5, {63.9, 30.4}}
}

---------------- Globals  ----------------

CRYSTALS = {0, 0, 0, 0, 0}

ZONE = 'SW'

---------------- Timers ----------------


---------------- Addon Functions ----------------

function GetPlayerPosition()
	local map = C_Map.GetBestMapForUnit("player")
	local position = C_Map.GetPlayerMapPosition(map, "player")
	x, y = position:GetXY()
	x = x * 100
	y = y * 100
	return x, y
end

function distanceFromCrystal(crystal)
	pX, pY = GetPlayerPosition()
	cX, cY = crystal[1], crystal[2]
	dX, dY = pX - cX, pY - cY

	dist = sqrt((dX*dX) + (dY*dY))
	return dist
end

function CountPickedCrystal()
	ARR = nil
	if ZONE == 'SW' then
		ARR = STORMWIND_POS
	else
		ARR = ORGRIMMAR_POS
	end

	for i = 1, 19 do
		if distanceFromCrystal(ARR[i][2]) <= MAX_PICKING_DISTANCE then
			CRYSTALS[ARR[i][1]] = CRYSTALS[ARR[i][1]] + 1
		end
	end
end

function PrintCrystalCount()
	total = ''
	ARR = nil
	if ZONE == 'SW' then
		ARR = STORMWIND_LOCATIONS
	else
		ARR = ORGRIMMAR_LOCATIONS
	end

	for i=1,5 do
		total = total .. ARR[i] .. ':  ' .. CRYSTALS[i] .. '/2\n'
	end

	StormwindC:SetText(total)
end


---------------- Buttons Click ----------------



---------------- Events functions ----------------
events = {}
function events:UNIT_SPELLCAST_SUCCEEDED(unitTarget, castGUID, spellID)
	if unitTarget == "player" then
		if spellID == 143394 then
			-- Picking up a crystal<>
			CountPickedCrystal()
		end
	end
end
---------------- Events handler ----------------

function OnUpdateFunction(self, deltaTime)
	if CVT_Frame:IsVisible() then
		PrintCrystalCount()
	end
end

function OnEventFunction(self, event, ...)
	events[event](self, ...)
end


---------------- Slash Commands ----------------

function setStormwind(msg, editBox)
	CRYSTALS = {0, 0, 0, 0, 0}
	ZONE = 'SW'
	CVT_Frame:Show()
end

SLASH_CSW1 = "/csw"
SlashCmdList["CSW"] = setStormwind

function setOrgrimmar(msg, editBox)
	CRYSTALS = {0, 0, 0, 0, 0}
	ZONE = 'OG'
	CVT_Frame:Show()
end

SLASH_COG1 = "/cog"
SlashCmdList["COG"] = setOrgrimmar

function hideCrystalCounter(msg, editBox)
	CVT_Frame:Hide()
end

SLASH_CHIDE1 = "/chide"
SlashCmdList["CHIDE"] = hideCrystalCounter

function testFire(msg, editBox)
	CountPickedCrystal()
end

SLASH_CTFIRE1 = "/ctfire"
SlashCmdList["CTFIRE"] = testFire

movable = false

function movability(msg, editBox)
	movable = movable == false
	CVT_Frame:SetMovable(movable)
	print("Movable: " .. tostring(movable))
end

SLASH_CMOVE1 = "/cmove"
SlashCmdList["CMOVE"] = movability

function helper(msg, editBox)
	print("/csw - Stormwind (resets counting)\n/cog - Orgrimmar (resets counting)\n/cmove - Toggle moving the frame\n/chide - Hide stats")
end

SLASH_CHELP1 = "/chelp"
SlashCmdList["CHELP"] = helper

